# $Progeny: auto_partition-ia64.py,v 1.8 2002/02/18 19:32:58 jlicquia Exp $

import pgi.auto_partition_base
import pgi.common

from pgi.common import EFIBOOT_MB, TRUE, FALSE

def get_partitions(freespace):
    """Returns a list of quadruples with mount point, fstype, size in
    MB, and whether the partition must be primary.
    """

    return pgi.auto_partition_base.calc_partitions \
           (freespace, get_standard_partitions())

def get_standard_partitions():
    parts = pgi.auto_partition_base.get_standard_partitions()
    if not parts:
        return None

    # If ia64 needs more partitions, be sure to add them in front of
    # this.  This guy must come last since he needs to be primary.
    parts.append(("/boot/efi", "EFI boot", EFIBOOT_MB, TRUE))

    return parts
